//lets go ahead and add some function battle support to soap!
local battleModSet
//whatever im gonna work on this later
addHook("PlayerThink", function(p)
	if (battleModSet) or not (CBW_Battle and CBW_Battle.SkinVars) then 
		return 
	end
	battleModSet = true
	
	
	CBW_Battle.SkinVars["soapthehedge"] = {
 		weight = 185,
 		shields = 1,
		special = CBW_Battle.Action.SuperSpinJump,
 		guard_enabled = true,
 		guard_frame = 2,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon,
 		func_priority_ext = PriorityFunction
	}
end)

addHook("PlayerThink", function(p)
	if CBW_Battle then
		if p.mo.skin == "soapthehedge" and CBW_Battle.BattleGametype() then
			p.charability = CA_HOMINGTHOK
			p.actionspd = 84 * FRACUNIT
			p.charflags = SF_SUPER|SF_HIRES|SF_DASHMODE|SF_CANBUSTWALLS|SF_FASTEDGE|SF_RUNONWATER|SF_NOSUPERSPRITES|SF_MULTIABILITY
		else
			if p.mo.skin == "soapthehedge" then
				p.charability = CA_JUMPTHOK
				p.actionspd = 30 * FRACUNIT
				p.charflags = SF_SUPER|SF_HIRES|SF_DASHMODE|SF_CANBUSTWALLS|SF_FASTEDGE|SF_RUNONWATER|SF_NOSUPERSPRITES
			end
		end
	end
end)
/* Hi, CobaltBW here.
This is a tutorial action script that will teach you how to create a character's special moves for use with BattleMod.
To help explain the process, I'll be adding multiple comments detailing how everything works and what we need to do to make our script work properly.

A quick overview of what you'll need:
	local variable at the top level
	A ThinkFrame hook
	"if CBW_Battle" check
	A function for your action script, stored locally or globally
	A character that will use the function, defined via CBW_Battle.SkinVars[<yourskinname>]

You may also want to enable 'battledebug 10' in the console as your are testing your character's abilities.
This will display battle- and action-related variables in real time to help you troubleshoot any issues you may come across along the way.


Let's begin! */

/*
--First it's important that we keep track of whether BattleMod has been loaded so that we can tell the game when to create our function.
--To do this, we're going to start off by creating a local variable.
local ScriptLoaded = false
--Now let's encase the rest of our code inside of ThinkFrame...
addHook("ThinkFrame", function()


	--... so that we can check each frame to see if the script has been loaded yet.
	if not(ScriptLoaded)
		and CBW_Battle --CBW_Battle is the master table for all of BattleMod's functions. Attempting to run our scripts without Battle loaded will result in a lua error, so we have to check before trying to run the rest of the code.
		then
		ScriptLoaded = true --Flip this to true so that we don't try to run this code more than once.
		local B = CBW_Battle --Just for convenience, we're going to truncate this table; it'll make writing functions a little less cumbersome.
		
		//alright, now this is where soap (hopefully) gets his abilities changed for battlemod
		if player.mo.skin == "soapthehedge" then //some nesting, got kinda confused here
			if not B then
				if player.solchar ~= "nil" and player.mo.skin == "soapthehedge" then //should probably worry about solchar stuff
					if not player.solchar.istransformed then
						player.charability = CA_JUMPTHOK
						player.actionspd = 30 * FRACUNIT
					end
				else
					player.charability = CA_JUMPTHOK
					player.actionspd = 30 * FRACUNIT
				end
			else
				if player.mo.skin == "soapthehedge" then //stop messing with the other skins abilities!!
					player.charability = CA_HOMINGTHOK
					player.actionspd = 84 * FRACUNIT
				end
			end
		end
	end
end)

//sms moment
*/